$!-----------------------------------------------------------------------------
$! BUILD_YAHMAIL.COM
$!
$! P1-4 == BUILD, COMPILE, LINK or empty (builds)
$! P1-4 == MIME
$! P1-4 == PMDF
$! P1-4 == language (default EN)
$!
$! 08-JUN-2002  MGD  allow building using JUST:module
$! 19-MAR-2002  MGD  force MIME if PMDF
$! 03-NOV-2000  MGD  v1.4.0, use CGILIB object module,
$!                           compile specific PMDF SENDMSG module
$! 02-APR-2000  MGD  v1.3.0, support PMDF and MIME-kludge
$! 15-JAN-2000  MGD  v1.2.0, generalize for WASD and non-WASD builds
$! 22-JUN-1999  MGD  initial
$!-----------------------------------------------------------------------------
$!
$ IF P1 .EQS. "DIST"
$ THEN
$!   (distribution build - not used on your average site)
$    @BUILD_YAHMAIL
$    @BUILD_YAHMAIL MIME
$!   (make sure it links!)
$    @BUILD_YAHMAIL MIME LINK
$!   (non-English message modules)
$    @BUILD_YAHMAIL MIME JUST:LANG DE
$!   (PMDF-specific module)
$    @BUILD_YAHMAIL MIME PMDF JUST:SENDMSG
$    EXIT
$ ENDIF
$!
$!(marshal the build parameters)
$ BUILD = "BUILD"
$ IF P1 .EQS. "BUILD" THEN BUILD = P1
$ IF P2 .EQS. "BUILD" THEN BUILD = P2
$ IF P3 .EQS. "BUILD" THEN BUILD = P3
$ IF P4 .EQS. "BUILD" THEN BUILD = P4
$ IF P1 .EQS. "COMPILE" THEN BUILD = P1
$ IF P2 .EQS. "COMPILE" THEN BUILD = P2
$ IF P3 .EQS. "COMPILE" THEN BUILD = P3
$ IF P4 .EQS. "COMPILE" THEN BUILD = P4
$ IF P1 .EQS. "LINK" THEN BUILD = P1
$ IF P2 .EQS. "LINK" THEN BUILD = P2
$ IF P3 .EQS. "LINK" THEN BUILD = P3
$ IF P4 .EQS. "LINK" THEN BUILD = P4
$ MIME = ""
$ IF P1 .EQS. "MIME" THEN MIME = P1
$ IF P2 .EQS. "MIME" THEN MIME = P2
$ IF P3 .EQS. "MIME" THEN MIME = P3
$ IF P4 .EQS. "MIME" THEN MIME = P4
$ PMDF = ""
$ IF P1 .EQS. "PMDF" THEN PMDF = P1
$ IF P2 .EQS. "PMDF" THEN PMDF = P2
$ IF P3 .EQS. "PMDF" THEN PMDF = P3
$ IF P4 .EQS. "PMDF" THEN PMDF = P4
$ IF PMDF .EQS. "PMDF" THEN MIME= "MIME"
$ LANGUAGE = "EN"
$ IF P1 .NES. "" .AND. P1 .NES. "BUILD" .AND. P1 .NES. "COMPILE" .AND. -
     P1 .NES. "LINK" .AND. P1 .NES. "PMDF" .AND. P1 .NES. "MIME" -
     THEN LANGUAGE = P1
$ IF P2 .NES. "" .AND. P2 .NES. "BUILD" .AND. P2 .NES. "COMPILE" .AND. -
     P2 .NES. "LINK" .AND. P2 .NES. "PMDF" .AND. P2 .NES. "MIME" -
     THEN LANGUAGE = P2
$ IF P3 .NES. "" .AND. P3 .NES. "BUILD" .AND. P3 .NES. "COMPILE" .AND. -
     P3 .NES. "LINK" .AND. P3 .NES. "PMDF" .AND. P3 .NES. "MIME" -
     THEN LANGUAGE = P3
$ IF P4 .NES. "" .AND. P4 .NES. "BUILD" .AND. P4 .NES. "COMPILE" .AND. -
     P4 .NES. "LINK" .AND. P4 .NES. "PMDF" .AND. P4 .NES. "MIME" -
     THEN LANGUAGE = P4
$ JUST = ""
$ IF F$ELEMENT(0,":",P1) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P1)
$ IF F$ELEMENT(0,":",P2) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P2)
$ IF F$ELEMENT(0,":",P3) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P3)
$ IF F$ELEMENT(0,":",P4) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P4)
$!
$ APPLICATION = "YAHMAIL"
$!
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "Building ""''APPLICATION'""" +-
  " for ""''F$GETSYI("ARCH_NAME")'"""
$!
$ ARCH_NAME = F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE")
$ IF ARCH_NAME .EQS. "ALPHA" THEN ARCH_NAME = "AXP"
$!
$ DEFINES = "/DEFINE=(_VMS_V6_SOURCE=1,__VMS_VER=60000000," +-
            "__CRTL_VER=60000000,CGILIB_OBJECT_MODULE)"
$ IF MIME .EQS. "MIME" THEN DEFINES = DEFINES - ")" + ",YAHMAIL_MUNPACK=1)"
$ IF PMDF .EQS. "PMDF"
$ THEN
$    DEFINES = DEFINES - ")" + ",YAHMAIL_PMDF=1)"
$ ENDIF
$!
$ LINK_OPTIONS = F$SEARCH("''APPLICATION'_''ARCH_NAME'.OPT")
$ IF LINK_OPTIONS .NES. "" -
     THEN LINK_OPTIONS = "," + F$ELEMENT(0,";",LINK_OPTIONS) + "/OPTIONS"
$!
$ IF F$SEARCH("OBJ_''ARCH_NAME'.DIR") .EQS. "" -
     THEN CREATE/DIR [.OBJ_'ARCH_NAME']
$ OBJECT_DIR = "[.OBJ_''ARCH_NAME']"
$!
$ IF F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE") .EQS. "VAX"
$ THEN
$    CC_OPTIONS = "/DECC /OPT /STAND=RELAXED /PREFIX=ALL " +-
                  "'DEFINES' /INC=[] " +-
                  "/WARN=(DISABLE=(PREOPTW,IMPLICITFUNC,ADDRCONSTEXT))
$ ELSE
$    CC_OPTIONS = "/DECC /OPT /STAND=RELAXED /PREFIX=ALL " +-
                  "'DEFINES' /INC=[] " +-
                  "/WARN=(DISABLE=(PREOPTW,IMPLICITFUNC,ADDRCONSTEXT))
$ ENDIF
$!
$ IF BUILD .EQS. "BUILD" .OR. "BUILD .EQS. "COMPILE"
$ THEN
$    SET NOON
$    SET VERIFY
$!(compile yahMAIL components)
$ IF JUST .NES. "" THEN GOTO 'JUST'
$ ADDRLIST:
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' AddrList
$ IF JUST .NES. "" THEN GOTO END_JUST
$ CALLMAIL:
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' CallMail
$ IF JUST .NES. "" THEN GOTO END_JUST
$ OTHER:
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' Other
$ IF JUST .NES. "" THEN GOTO END_JUST
$ PRIVATE:
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' Private
$ IF JUST .NES. "" THEN GOTO END_JUST
$ PROFILE:
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' Profile
$ IF JUST .NES. "" THEN GOTO END_JUST
$ PUBLIC:
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' Public
$ IF JUST .NES. "" THEN GOTO END_JUST
$ SENDMSG:
$ IF PMDF .EQS. "PMDF"
$    THEN CC 'CC_OPTIONS' /OBJ='OBJECT_DIR'SendMsg_PMDF SendMsg
$    ELSE CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' SendMsg
$ ENDIF
$ IF JUST .NES. "" THEN GOTO END_JUST
$ SIGFILE:
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' SigFile
$ IF JUST .NES. "" THEN GOTO END_JUST
$ VIEWMSG:
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' ViewMsg
$ IF JUST .NES. "" THEN GOTO END_JUST
$ YAHMAIL:
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' yahMAIL
$ IF JUST .NES. "" THEN GOTO END_JUST
$ LANG:
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' lang_'LANGUAGE'
$ IF JUST .NES. "" THEN GOTO END_JUST
$!(compile CGILIB component)
$ CGILIB:
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' CGILIB
$ IF JUST .NES. "" THEN GOTO END_JUST
$ MIME:
$!   'F$VERIFY(0)
$    IF MIME .EQS. "MIME"
$    THEN
$    SET VERIFY
$!(compile munpack components)
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' [.munpack]unixos
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' [.munpack]unixunpk
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' [.munpack]decode
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' [.munpack]uudecode
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' [.munpack]codes
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' [.munpack]string
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' [.munpack]part
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' [.munpack]xmalloc
$ CC 'CC_OPTIONS' /OBJ='OBJECT_DIR' [.munpack]md5c
$!   'F$VERIFY(0)
$    ENDIF
$    SET ON
$    IF JUST .NES. "" THEN GOTO END_JUST
$ ENDIF
$!
$ IF BUILD .EQS. "BUILD" .OR. BUILD .EQS. "LINK"
$ THEN
$    IF F$TRNLNM("HT_ROOT") .EQS. ""
$       THEN EXECUTABLE = "'APPLICATION'_'ARCH_NAME'.EXE"
$       ELSE EXECUTABLE = "HT_EXE:'APPLICATION'.EXE"
$    ENDIF
$    SET NOON
$    IF MIME .EQS. "MIME"
$    THEN
$       IF PMDF .EQS. "PMDF"
$       THEN
$          SET VERIFY
$!(linking MIME version with PMDF libraries)
$ LINK/NOTRACE/EXECUTABLE='EXECUTABLE' -
  'OBJECT_DIR'AddrList,CallMail,Other, -
  Private,Profile,Public,SigFile,SendMsg_PMDF,ViewMsg,yahMAIL, -
  CGILIB, -
  lang_'LANGUAGE', -
  unixos,unixunpk,decode,uudecode,codes, -
  string,part,xmalloc'LINK_OPTIONS', -
  PMDF_EXE:PMDFSHR_LINK.OPT/OPT
$!         'F$VERIFY(0)
$       ELSE
$          SET VERIFY
$!(linking MIME version)
$ LINK/NOTRACE/EXECUTABLE='EXECUTABLE' -
  'OBJECT_DIR'AddrList,CallMail,Other, -
  Private,Profile,Public,SigFile,SendMsg,ViewMsg,yahMAIL, -
  CGILIB, -
  lang_'LANGUAGE', -
  unixos,unixunpk,decode,uudecode,codes, -
  string,part,xmalloc,md5c'LINK_OPTIONS'
$!         'F$VERIFY(0)
$       ENDIF
$    ELSE
$       SET VERIFY
$!      (linking vanilla version)
$ LINK/NOTRACE/EXECUTABLE='EXECUTABLE' -
  'OBJECT_DIR'AddrList,CallMail,Other, -
  Private,Profile,Public,SigFile,SendMsg,ViewMsg,yahMAIL, -
  CGILIB, -
  lang_'LANGUAGE''LINK_OPTIONS'
$!      'F$VERIFY(0)
$    ENDIF
$    SET ON
$ ENDIF
$ SET PROTECTION=W:RE 'EXECUTABLE'
$ PURGE/NOLOG 'OBJECT_DIR'
$ END_JUST:
$!'F$VERIFY(0)
$!
$!-----------------------------------------------------------------------------
